<template>
  <div>
    <div class="text-right mb-3">
      <button class="btn btn-success mr-3" @click.prevent="load">
        Load PIC
      </button>

      <template v-if="isAdd">
        <template v-if="loadingSave">
          <button class="btn btn-primary mr-3">
            <b-spinner
              variant="light"
              style="height: 1rem; width: 1rem;"
              label="Spinning"
            ></b-spinner>
          </button>
        </template>
        <template v-else>
          <button class="btn btn-primary mr-3" @click.prevent="save()">
            Simpan Change PIC
          </button>
        </template>
      </template>
      <template v-else>
        <button class="btn btn-primary mr-3" disabled>
          Simpan Change PIC
        </button>
      </template>

      <template v-if="activeEdit">
        <a class="text-primary font-weight-bold" @click.prevent="showErrorAdd">
          <i class="flaticon2-plus"></i>
        </a>
      </template>
      <template v-else>
        <a class="text-primary font-weight-bold" @click.prevent="addRowPic">
          <i class="flaticon2-plus"></i>
        </a>
      </template>
    </div>
    <div class="table-responsiv">
      <table
        class="table table-head-custom table-vertical-center table-head-bg table-borderless"
      >
        <thead>
          <tr>
            <th style="min-width: 40px">Inisial</th>
            <th>Nama</th>
            <th>Change Management Item</th>
            <th class="text-center">Aksi</th>
          </tr>
        </thead>
        <template
          v-if="
            this.$store.getters.getterPicManagement.length == 0 ||
              this.$store.getters.getterPicManagement == '400'
          "
        >
          <tbody>
            <tr
              v-if="isLoading"
              v-bind:class="{
                'd-none': templateEmpty
              }"
            >
              <td colspan="4">
                <div class="text-center">
                  <i class="flaticon2-open-box text-secondary icon-3x"></i>

                  <template v-if="isEmpty">
                    <h4>
                      Data tidak ditemukan.
                    </h4>
                  </template>
                  <template v-else>
                    <h4>
                      Data kosong.
                    </h4>
                  </template>
                </div>
              </td>
            </tr>
            <tr v-else>
              <td class="text-center" colspan="4">
                <b-spinner variant="primary" label="Spinning"></b-spinner>
              </td>
            </tr>
          </tbody>
        </template>
        <template v-else>
          <tbody>
            <template
              v-for="(item, i) in this.$store.getters.getterPicManagement"
            >
              <tr v-bind:key="i">
                <td>
                  <template>
                    <div v-bind:class="'pic-change-text-' + i">
                      {{ item.pic.code }}
                    </div>

                    <div v-bind:class="'d-none pic-change-form-' + i">
                      <b-form-select
                        v-model="selected.pic"
                        :options="options.initial"
                      ></b-form-select>
                    </div>
                  </template>
                </td>
                <td>{{ item.pic.name }}</td>
                <td>
                  <template>
                    <div v-bind:class="'pic-change-text-' + i">
                      {{ item.change_management_item.issue }}
                    </div>

                    <div v-bind:class="'d-none pic-change-form-' + i">
                      <b-form-select
                        v-model="selected.list_management"
                        :options="options.mci"
                      ></b-form-select>
                    </div>
                  </template>
                </td>
                <td class="text-center">
                  <template>
                    <div v-bind:id="'pic-change-button-' + i">
                      <a
                        class="btn btn-light-success font-weight-bolder font-size-sm"
                        @click.prevent="editPicChange(item.id, i)"
                      >
                        <i class="flaticon-edit"></i>
                      </a>

                      <template>
                        <a
                          class="btn btn-light-danger d-none font-weight-bolder font-size-sm"
                          v-bind:id="'loading-delete-' + item.id"
                        >
                          <b-spinner
                            variant="light"
                            style="width: 1rem; height: 1rem;"
                            label="Spinning"
                          ></b-spinner>
                        </a>
                      </template>
                      <template>
                        <a
                          class="btn btn-light-danger font-weight-bolder font-size-sm"
                          @click.prevent="deletePic(item)"
                          v-bind:id="'delete-text-' + item.id"
                        >
                          <i class="flaticon-delete"></i>
                        </a>
                      </template>
                    </div>
                    <div class="d-none" v-bind:id="'pic-change-cancel-' + i">
                      <a
                        class="btn btn-light-danger font-weight-bolder font-size-sm"
                        @click.prevent="cancelEdit(i)"
                      >
                        <i class="flaticon2-cross"></i>
                      </a>
                    </div>
                  </template>
                </td>
              </tr>
            </template>
          </tbody>
        </template>
        <template>
          <tbody
            v-bind:class="{
              'd-none': addPic
            }"
          >
            <tr>
              <td>
                <template>
                  <b-form-select v-model="selected.pic" class="mb-3">
                    <b-form-select-option
                      v-for="(pic, i) in this.$store.getters
                        .getterPicChangeMangement"
                      v-bind:key="i"
                      :value="pic.code + '/' + pic.name + '/0/0'"
                    >
                      {{ pic.name }}
                    </b-form-select-option>
                  </b-form-select>
                </template>
              </td>
              <td></td>
              <td>
                <template>
                  <b-form-select
                    v-model="selected.list_management"
                    class="mb-3"
                  >
                    <b-form-select-option
                      v-for="(mic, i) in this.$store.getters
                        .getterManagementItem"
                      v-bind:key="i"
                      :value="
                        mic.code +
                          '/' +
                          mic.type.code +
                          '/' +
                          mic.type.name +
                          '/' +
                          mic.issue
                      "
                    >
                      {{ mic.code + " - " + mic.issue }}
                    </b-form-select-option>
                  </b-form-select>
                </template>
              </td>
              <td class="text-center">
                <a class="btn btn-light-danger" @click.prevent="cancelAddPic">
                  <i class="flaticon2-cross"></i>
                </a>
              </td>
            </tr>
          </tbody>
        </template>
      </table>
    </div>

    <v-app
      v-bind:class="{
        'd-none': isModalDeletePic
      }"
    >
      <v-dialog
        v-model="dialogPic"
        transition="dialog-top-transition"
        max-width="400"
      >
        <v-card>
          <v-card-title class="headline">Konfirmasi Hapus Data</v-card-title>

          <v-card-text>
            Apakah anda yakin ingin menghapus data
            <b>
              {{
                this.currentDelete == null
                  ? "ini"
                  : "'" + this.currentDelete + "'"
              }}
            </b>
            ?
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn color="green darken-1" text @click="deleteDesign()">
              Hapus
            </v-btn>

            <v-btn color="green darken-1" text @click="closeDialog">
              Batal
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-app>
  </div>
</template>

<script>
import {
  GET_PIC_CHANGE,
  GET_PIC_CHANGE_MANAGEMENT,
  GET_LIST_MANAGEMENT_ITEM,
  SAVE_PIC_CHANGE_MANAGEMENT,
  DELETE_PIC_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";
export default {
  name: "Pic",
  data() {
    return {
      data: {
        pic: [
          {
            initial: "RDW",
            name: "Ridwan",
            cmi: "Item 1"
          },
          {
            initial: "ARS",
            name: "Aris",
            cmi: "Item 2"
          },
          {
            initial: "IMG",
            name: "Ilham",
            cmi: "Item 3"
          }
        ]
      },
      options: {
        initial: { text: "loading..." },
        mci: { text: "loading..." }
      },
      selected: {
        pic: "",
        list_management: ""
      },
      currentDelete: null,
      addPic: true,
      isEmpty: false,
      isLoading: true,
      isAdd: false,
      templateEmpty: false,
      activeEdit: false,
      dialogPic: false,
      isModalDeletePic: true,
      loadingSave: false
    };
  },
  methods: {
    async addRowPic() {
      var check = this.$store.getters.getterPicManagement;

      if (check == "400" || check.length == 0) {
        this.isEmpty = false;
        this.isLoading = true;
        this.templateEmpty = true;
        this.addPic = false;
        this.isAdd = true;
      } else {
        this.isAdd = true;
        this.addPic = false;
      }

      await this.$store.dispatch(GET_LIST_MANAGEMENT_ITEM, {
        id: this.$route.params.id_change_management
      });
      await this.$store.dispatch(GET_PIC_CHANGE);
    },

    cancelAddPic() {
      this.addPic = true;
      this.activeEdit = false;
      this.isAdd = false;
    },

    async editPicChange(idItem, id) {
      var active = this.addPic;
      if (active == false) {
        this.$bvToast.toast("Selesaikan Tambah data terlebih dahulu", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        if (this.activeEdit == true) {
          this.$bvToast.toast("Selesaikan Edit data terlebih dahulu", {
            title: "Warning",
            variant: "danger",
            solid: true
          });
        } else {
          this.activeEdit = true;
          this.isAdd = true;
          var input = document.getElementsByClassName("pic-change-form-" + id);
          var text = document.getElementsByClassName("pic-change-text-" + id);

          for (var i = 0; i < input.length; i++) {
            input[i].classList.remove("d-none");
            text[i].classList.add("d-none");
          }

          // button
          var action = document.getElementById("pic-change-button-" + id);
          var cancel = document.getElementById("pic-change-cancel-" + id);

          action.classList.add("d-none");
          cancel.classList.remove("d-none");

          var option = [];
          await this.$store.dispatch(GET_PIC_CHANGE);
          this.options.initial = "";
          var picOption = this.$store.getters.getterPicChangeMangement;
          for (var p = 0; p < picOption.length; p++) {
            option.push({
              value:
                picOption[p].code +
                "/" +
                picOption[p].name +
                "/" +
                id +
                "/" +
                idItem,
              text: picOption[p].name
            });
          }

          this.options.initial = option;

          var ops = [];
          await this.$store.dispatch(GET_LIST_MANAGEMENT_ITEM, {
            id: this.$route.params.id_change_management
          });
          this.options.mci = "";
          var listOption = this.$store.getters.getterManagementItem;
          for (var x = 0; x < listOption.length; x++) {
            ops.push({
              value:
                listOption[x].code +
                "/" +
                listOption[x].type.code +
                "/" +
                listOption[x].type.name +
                "/" +
                listOption[x].issue,
              text: listOption[x].code + " - " + listOption[x].issue
            });
          }

          this.options.mci = ops;
        }
      }
    },

    async load() {
      this.isLoading = false;
      await this.$store.dispatch(GET_PIC_CHANGE_MANAGEMENT, {
        id: this.$route.params.id_change_management
      });
      this.isLoading = true;

      if (this.$store.getters.getterPicManagement == "400") {
        this.isLoading = true;
        this.isEmpty = true;
      } else {
        this.isLoading = true;
        this.isEmpty = false;
      }
    },

    async save() {
      var pic = this.selected.pic;
      var management = this.selected.list_management;

      if (pic == "" || management == "") {
        this.$bvToast.toast("Pastikan semua field terisi", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        var picSplit = pic.split("/");
        var managementSplit = management.split("/");

        var id = picSplit[2];

        var send;

        if (id != 0) {
          var idItem = picSplit[3];
          send = [
            {
              id: idItem,
              pic: {
                code: picSplit[0],
                name: picSplit[1]
              },
              change_management_item: {
                code: managementSplit[0],
                type: {
                  code: managementSplit[1],
                  name: managementSplit[2]
                },
                issue: managementSplit[3]
              }
            }
          ];
        } else {
          send = [
            {
              id: null,
              pic: {
                code: picSplit[0],
                name: picSplit[1]
              },
              change_management_item: {
                code: managementSplit[0],
                type: {
                  code: managementSplit[1],
                  name: managementSplit[2]
                },
                issue: managementSplit[3]
              }
            }
          ];
        }

        this.loadingSave = true;
        await this.$store.dispatch(SAVE_PIC_CHANGE_MANAGEMENT, {
          id: this.$route.params.id_change_management,
          send: send
        });
        this.loadingSave = false;

        if (this.$store.getters.getterPicManagement.length == 0) {
          this.load();
          this.$bvToast.toast("Data PIC berhasil disimpan", {
            title: "Success",
            variant: "success",
            solid: true
          });
          this.addPic = true;
          this.selected.pic = "";
          this.selected.list_management = "";
          this.isAdd = false;
          this.activeEdit = false;
        } else {
          var input = document.getElementsByClassName("pic-change-form-" + id);
          var text = document.getElementsByClassName("pic-change-text-" + id);

          for (var i = 0; i < input.length; i++) {
            input[i].classList.add("d-none");
            text[i].classList.remove("d-none");
          }

          // button
          var action = document.getElementById("pic-change-button-" + id);
          var cancel = document.getElementById("pic-change-cancel-" + id);

          action.classList.remove("d-none");
          cancel.classList.add("d-none");

          this.load();
          this.$bvToast.toast("Data PIC berhasil disimpan", {
            title: "Success",
            variant: "success",
            solid: true
          });
          this.addPic = true;
          this.selected.pic = "";
          this.selected.list_management = "";
          this.isAdd = false;
          this.activeEdit = false;
        }
      }
    },

    cancelEdit(id) {
      var input = document.getElementsByClassName("pic-change-form-" + id);
      var text = document.getElementsByClassName("pic-change-text-" + id);

      for (var i = 0; i < input.length; i++) {
        input[i].classList.add("d-none");
        text[i].classList.remove("d-none");
      }

      // button
      var action = document.getElementById("pic-change-button-" + id);
      var cancel = document.getElementById("pic-change-cancel-" + id);

      action.classList.remove("d-none");
      cancel.classList.add("d-none");

      this.options.initial = { text: "loading..." };
      this.options.mci = { text: "loading..." };
      this.activeEdit = false;
      this.isAdd = false;
    },
    showErrorAdd() {
      this.$bvToast.toast("Selesaikan Edit data terlebih dahulu", {
        title: "Warning",
        variant: "danger",
        solid: true
      });
    },
    showModalDelete(item) {
      this.dialogPic = true;
      this.isModalDeletePic = false;
      this.currentDelete = item;
    },
    closeDialog() {
      this.isModalDeletePic = true;
      this.dialogPic = false;
      this.currentDelete = null;
    },
    async deletePic(item) {
      var id = item.id;
      var id_change = this.$route.params.id_change_management;

      var loading = document.getElementById("loading-delete-" + item.id);
      var text = document.getElementById("delete-text-" + item.id);

      loading.classList.remove("d-none");
      text.classList.add("d-none");
      await this.$store.dispatch(DELETE_PIC_CHANGE_MANAGEMENT, {
        id: id,
        id_change_management: id_change
      });
      loading.classList.add("d-none");
      text.classList.remove("d-none");

      this.loadingDelete = false;
      this.$bvToast.toast("Hapus data berhasil", {
        title: "Success",
        variant: "success",
        solid: true
      });
    }
  }
};
</script>
